<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { defaultSettings } from "./settings";
  const dispatch = createEventDispatcher();

  export let settings: GameSettings = defaultSettings;
  export let readonly: boolean = false;

  const minGoal = 1;
  const maxGoal = 999;

  let goal: number = settings.goal;
  $: goal = Math.abs(goal | 0);

  $: settingsChange = {
    goal,
  };

  $: dispatch("settings_change", settingsChange);
</script>

<section>
  <label for="goal">
    <div>Points required to win</div>
    <input
      id="goal"
      type="number"
      bind:value={goal}
      min={minGoal}
      max={maxGoal}
      {readonly}
      on:blur={() => {
        goal = Math.min(maxGoal, Math.max(minGoal, goal));
      }}
    />
  </label>
</section>

<style>
  label {
    display: inline-block;
    margin-bottom: 1rem;
  }
</style>
